angular.module('beamng.apps')
.directive('asciigear', ['logger', 'bngApi', 'StreamsManager', function (logger, bngApi, StreamsManager) {
  return {
    template: '<div class="asciigear" id="asciigear" style="height: 100%;padding: 0px;">' + 
	'<pre style="background: black; color:white; padding: 4px;margin:0px;" id="aff"><span class="cornTopLeft">█</span><span class="top">█████</span><span class="cornTopRight">█</span><br><span class="leftTop">█</span><span class="diagLeftTop">\\ </span><span class="midTop">|</span><span class="diagRightTop"> /</span><span class="rightTop">█</span><br><span class="leftTop">█</span><span class="diagLeftTop"> \\</span><span class="midTop">|</span><span class="diagRightTop">/ </span><span class="rightTop">█</span><br><span class="leftLMid">█</span><span class="leftMid">██</span><span class="Mid">█</span><span class="rightMid">██</span><span class="rightRMid">█</span><br><span class="leftBot">█</span><span class="diagLeftBot"> /</span><span class="midBot">|</span><span class="diagRightBot">\\ </span><span class="rightBot">█</span><br><span class="leftBot">█</span><span class="diagLeftBot">/ </span><span class="midBot">|</span><span class="diagRightBot"> \\</span><span class="rightBot">█</span><br><span class="cornBotLeft">█</span><span class="bot">█████</span><span class="cornBotRight">█</span><br></pre>'+
	'</div>',
	replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      var requiredStrems = ['engineInfo', 'electrics'];
		//logger.debug('<asciigear>1 Link! ');
      StreamsManager.add(requiredStrems);
	  
	  element.on('load', function () {	/*logger.debug('<asciigear>22222 load! ');*/});
        var svg = element[0].children[0];
      /*var settingsInterval;
		
		//actu_asciigear();
		settingsInterval = setInterval(function () {
			try {
			actu_asciigear();
			}
			catch(err) {
				svg.innerHTML = err.message;
			}
			//clearInterval(settingsInterval);
		}, 5000);*/
		
        // polling if svg is loaded
        /*settingsInterval = setInterval(function () {
          if (svg && svg.settingsChanged) {
            
            clearInterval(settingsInterval);
          }
        }, 200);*/

        scope.$on('VechicleChange', function () { 
          //svg.vechicleChanged(); 
        });
        
        scope.$on('VehicleFocusChanged', function (event, data) {
          /*if(data.mode == 1 && svg && svg.vehicleChanged) {
             svg.vehicleChanged();
          }*/
        });
		var unitSystem = 'km';
		// * 3.6 = m/s to km/h
		// * 2.23694 = m/s to mph
		var speedUnitMultiplier = 3.6;
		var speedUnitText ="kmh";

        scope.$on('SettingsChanged', function (event, data) {
			//logger.debug('<asciigear> received SettingsChanged event');
			unitSystem = data.values.uiUnitDistance;
			if(unitSystem == 'km') {
			speedUnitText = 'kmh';
			speedUnitMultiplier = 3.6;
		  } else if(unitSystem == 'mi') {
			speedUnitText = 'mph';
			speedUnitMultiplier = 2.23694;
		  } else {
			speedUnitText = 'm/s';
			speedUnitMultiplier = 1;
		  }
          /*if (svg && svg.settingsChanged) {
            //
            svg.settingsChanged(data);
          }*/
        });
		bngApi.engineLua('settings.requestState()');

        bngApi.engineLua('settings.requestState()');

		var selfapp = {};

selfapp.seg_on = function (cls){var x = document.getElementsByClassName(cls); for( var i=0; i<x.length ;i++){x[i].style.color = 'white';}}
selfapp.seg_of = function (cls){var x = document.getElementsByClassName(cls); for( var i=0; i<x.length ;i++){x[i].style.color = 'grey';}}

selfapp.asciigear_print7seg = function (A,B,C,D,E,F,G)
{
	if(A){selfapp.seg_on("top");}else{selfapp.seg_of("top");}
	if(B){selfapp.seg_on("rightTop");}else{selfapp.seg_of("rightTop");}
	if(C){selfapp.seg_on("rightBot");}else{selfapp.seg_of("rightBot");}
	if(D){selfapp.seg_on("bot");}else{selfapp.seg_of("bot");}
	if(E){selfapp.seg_on("leftBot");}else{selfapp.seg_of("leftBot");}
	if(F){selfapp.seg_on("leftTop");}else{selfapp.seg_of("leftTop");}
	if(G){selfapp.seg_on("leftMid");selfapp.seg_on("rightMid");selfapp.seg_on("Mid");}else{selfapp.seg_of("leftMid");selfapp.seg_of("rightMid");selfapp.seg_of("Mid");}
	
	if(A || F){selfapp.seg_on("cornTopLeft");}else{selfapp.seg_of("cornTopLeft");}
	if(A || B){selfapp.seg_on("cornTopRight");}else{selfapp.seg_of("cornTopRight");}
	if(D || E){selfapp.seg_on("cornBotLeft");}else{selfapp.seg_of("cornBotLeft");}
	if(D || C){selfapp.seg_on("cornBotRight");}else{selfapp.seg_of("cornBotRight");}
	
	if(B || C || G){selfapp.seg_on("rightRMid");}else{selfapp.seg_of("rightRMid");}
	if(E || F || G){selfapp.seg_on("leftLMid");}else{selfapp.seg_of("leftLMid");}	
	
	selfapp.seg_of("midBot");selfapp.seg_of("midTop");selfapp.seg_of("diagRightBot");selfapp.seg_of("diagLeftBot");selfapp.seg_of("diagRightTop");selfapp.seg_of("diagLeftTop");
}

selfapp.asciigear_print14seg = function (A,B,C,D,E,F,G1,G2,D1,D2,D3,D4,M1,M2,C1,C2,C3,C4)
{
	if(A){selfapp.seg_on("top");}else{selfapp.seg_of("top");}
	if(B){selfapp.seg_on("rightTop");}else{selfapp.seg_of("rightTop");}
	if(C){selfapp.seg_on("rightBot");}else{selfapp.seg_of("rightBot");}
	if(D){selfapp.seg_on("bot");}else{selfapp.seg_of("bot");}
	if(E){selfapp.seg_on("leftBot");}else{selfapp.seg_of("leftBot");}
	if(F){selfapp.seg_on("leftTop");}else{selfapp.seg_of("leftTop");}
	if(G1){selfapp.seg_on("leftMid");}else{selfapp.seg_of("leftMid");}
	if(G2){selfapp.seg_on("rightMid");}else{selfapp.seg_of("rightMid");}
	if(D1){selfapp.seg_on("diagLeftTop");}else{selfapp.seg_of("diagLeftTop");}
	if(D2){selfapp.seg_on("diagRightTop");}else{selfapp.seg_of("diagRightTop");}
	if(D3){selfapp.seg_on("diagLeftBot");}else{selfapp.seg_of("diagLeftBot");}
	if(D4){selfapp.seg_on("diagRightBot");}else{selfapp.seg_of("diagRightBot");}
	if(M1){selfapp.seg_on("midTop");}else{selfapp.seg_of("midTop");}
	if(M2){selfapp.seg_on("midBot");}else{selfapp.seg_of("midBot");}
	if(C1){selfapp.seg_on("cornTopLeft");}else{selfapp.seg_of("cornTopLeft");}
	if(C2){selfapp.seg_on("cornTopRight");}else{selfapp.seg_of("cornTopRight");}
	if(C3){selfapp.seg_on("cornBotLeft");}else{selfapp.seg_of("cornBotLeft");}
	if(C4){selfapp.seg_on("cornBotRight");}else{selfapp.seg_of("cornBotRight");}
	
	if(B || C || G2){selfapp.seg_on("rightRMid");}else{selfapp.seg_of("rightRMid");}
	if(E || F || G1){selfapp.seg_on("leftLMid");}else{selfapp.seg_of("leftLMid");}
	
	if(G1 || G2 || M1 || M2 || D1 || D2 || D3 || D4){selfapp.seg_on("Mid");}else{selfapp.seg_of("Mid");}
}

selfapp.asciigear_printlcd = function (cha)
{
	switch(cha)
	{
		case '0':
			selfapp.asciigear_print7seg(1,1,1,1,1,1,0); break;
		case '1':
			selfapp.asciigear_print7seg(0,1,1,0,0,0,0); break;
		case '2':
			selfapp.asciigear_print7seg(1,1,0,1,1,0,1); break;
		case '3':
			selfapp.asciigear_print7seg(1,1,1,1,0,0,1); break;
		case '4':
			selfapp.asciigear_print7seg(0,1,1,0,0,1,1); break;
		case '5':
			selfapp.asciigear_print7seg(1,0,1,1,0,1,1); break;
		case '6':
			selfapp.asciigear_print7seg(1,0,1,1,1,1,1); break;
		case '7':
			selfapp.asciigear_print7seg(1,1,1,0,0,0,0); break;
		case '8':
			selfapp.asciigear_print7seg(1,1,1,1,1,1,1); break;
		case '9':
			selfapp.asciigear_print7seg(1,1,1,1,0,1,1); break;
			
		case 'N':
			selfapp.asciigear_print14seg(0,1,1,0,1,1,0,0,1,0,0,1,0,0,1,1,1,1); break;
		case 'R':
			selfapp.asciigear_print14seg(1,1,0,0,1,1,1,1,0,0,0,1,0,0,1,0,1,1); break;
		case 'P':
			selfapp.asciigear_print14seg(1,1,0,0,1,1,1,1,0,0,0,0,0,0,1,0,1,0); break;
		case 'D':
			selfapp.asciigear_print14seg(1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,1,0); break;
	}
}

		


		var testVar = 0; // for the test mode
		var displayMode = 2;
		var offline = false;
		var Hold =0, Wold=0;
        scope.$on('streamsUpdate', function (event, streams) {
          //svg.update(streams);
		  //actu_asciigear();
		  
		  if(element[0].clientHeight != Hold || element[0].clientWidth !=Wold)
		  {
			  //constant
			   var fw = 8;		//default font width
			   var fh = 13+2;	//default font height
			   var cw = 40;		//Number of char in a line
			   var lh = 7;		//number of line
			   
			   var H = element[0].clientHeight - 0;
			   var W = element[0].clientWidth - 0;
			   var fsize = 13;
			   
			   /*if( W/(cw*fw)  *  (fh*lh) > H )
			   {*/
				   //use height
				   fsize = (H / lh) -2;
			   /*}
			   else
			   {
				   //use width
				   var h = W * ( (lh*fh)/(fw*cw) )
				   fsize = (h / lh) -2
			   }*/
			   svg.style.fontSize = Math.floor(fsize)+"px";
			   svg.style.lineHeight = (Math.floor(fsize)+2)+"px";
			   Hold = element[0].clientHeight;
			   Wold = element[0].clientWidth;
			   

		  }
		  
		  
		  var isStreamValid = streams.engineInfo && streams.engineInfo[0] !== undefined && streams.electrics;

		  var data = {};
		  if(isStreamValid)
		  {
				var rpm_max = Math.round(streams.engineInfo[1] / 1000) * 1000 + 1000; // we round up to the nearest 1000
				//var rpm = getRandomInt(0, 8000)
				
				 if (displayMode == 2) {
					// real data mode, no animation
					if(streams.electrics.wheelspeed) {
					  data.speedtext = Math.round(streams.electrics.wheelspeed * speedUnitMultiplier);
					} else if (streams.electrics.airspeed) {
					  data.speedtext = Math.round(streams.electrics.airspeed * speedUnitMultiplier);
					}
					(function () {
					  if(streams.engineInfo[13] == "manual") {
						var gear = streams.engineInfo[5];
						var gearStr = gear.toString();
						
						if(gear == 0) gearStr = 'N';
						else if(gear == -1) gearStr = 'R';
						else if(-gear > 1) gearStr = 'R' /*+ (-gear)*/; /*@TODO*/

						data.geartext = gearStr;
					  } else {
						data.geartext = ["P","R","N","D","2","1"][Math.round(streams.electrics.gear_A*5)];
					  }
					})();

					data.fuel = streams.engineInfo[11] / streams.engineInfo[12];
					data.parkingBrake = streams.electrics.parkingbrake;
					data.absWorking = streams.electrics.abs;
					data.signalL = streams.electrics.signal_L;
					data.signalR = streams.electrics.signal_R;
					data.waterTemp = streams.electrics.watertemp;
					data.lowBeam = streams.electrics.lowbeam;
					data.highBeam = streams.electrics.highbeam;
					data.rpm = (streams.electrics.rpm || 0.0);
					data.tc = streams.electrics.tcs;
					data.esp = streams.electrics.esp;

				  } else if (displayMode == 0) {
					// starting animation
					testVar = testVar + 0.04;
					if(testVar > 1) testVar = 1;
					data.speedtext = Math.round(testVar * 100) ;
					data.geartext = Math.round(testVar * 5);
					data.fuel = testVar;
					var boolTest = true;  //Math.round(testVar * 10) % 10;
					data.parkingBrake = boolTest;
					data.absWorking = boolTest;
					data.signalL = boolTest;
					data.signalR = boolTest;
					data.oilTemp = testVar;
					data.lowBeam = boolTest;
					data.highBeam = !boolTest;
					data.rpm = testVar;
					if(testVar >= 1) { 
					  testVar = 0; 
					  displayMode = 1;
					}

				  } else if (displayMode == 1) {
					// starting animation -> real data transition

					if(streams.electrics.wheelspeed) {
					  data.speedtext = Math.round(streams.electrics.wheelspeed * speedUnitMultiplier);
					} else {
					  data.speedtext = '';
					  speedUnitText.textContent = '';
					}

					(function () {
					  var gear = streams.engineInfo[5];
					  var gearStr = gear.toString();
					  if(gear == 0) {
						gearStr = 'N';
					  }
					  else if(gear == -1) {
						gearStr = 'R';
					  }
					  data.geartext = gearStr;
					})();

					data.parkingBrake = streams.electrics.parkingbrake;
					data.absWorking = streams.electrics.abs;
					data.signalL = streams.electrics.signal_L;
					data.signalR = streams.electrics.signal_R;
					data.lowBeam = streams.electrics.lowbeam;
					data.highBeam = streams.electrics.highbeam;
					if(streams.electrics.tcs == undefined)
						data.tc = 0;
					else
						data.tc = streams.electrics.tcs;
					if(streams.electrics.esp == undefined)
						data.esp = 0;
					else
						data.esp = streams.electrics.esp;
					
					var oilok = Math.abs(data.oilTemp - streams.electrics.oiltemp) &lt; 0.005;
					if(!oilok) data.oilTemp += (streams.electrics.oiltemp - data.oilTemp) * 0.2;

					var rpmperc = streams.electrics.rpm / rpm_max;
					var rpmok = Math.abs(data.rpm - rpmperc) &lt; 0.005;
					if(!rpmok) data.rpm += (rpmperc - data.rpm) * 0.2;

					var fuelperc = streams.engineInfo[11] / streams.engineInfo[12];
					var fuelok = Math.abs(data.fuel - fuelperc) &lt; 0.005;
					if(!fuelok) data.fuel += (fuelperc - data.fuel) * 0.2;

					if(oilok && rpmok && fuelok) {
					  displayMode = 2;
					}
				  }
				
				//Display *********************************************
			  selfapp.asciigear_printlcd(data.geartext);
		  }
		  else
		  {
			  //printfc("Engine not found", "red");
			  offline =true;
		  }
        });

      scope.$on('$destroy', function () {
        StreamsManager.remove(requiredStrems);
      });
    }
  };
}]);